﻿Public Class WebForm1
  Inherits System.Web.UI.Page

  Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    igWHDG.DataSource = MakeTableDataSet()
    igWHDG.DataKeyFields = "id"
    igWHDG.DataBind()
  End Sub

  Private Function MakeTableDataSet() As DataSet
    Dim dataSet As DataSet = New DataSet
    dataSet.Tables.Add(MakeTable)
    Return dataSet
  End Function

  Private Function MakeTable() As DataTable
    ' Create a new DataTable.
    Dim table As System.Data.DataTable = New DataTable("Table")
    Dim column As DataColumn
    Dim row As DataRow

    ' Create new DataColumn, set DataType, 
    ' ColumnName and add to DataTable.    
    column = New DataColumn()
    column.DataType = System.Type.[GetType]("System.Int32")
    column.ColumnName = "id"
    column.[ReadOnly] = True
    ' Add the Column to the DataColumnCollection.
    table.Columns.Add(column)

    ' Create second column.
    column = New DataColumn()
    column.DataType = System.Type.[GetType]("System.String")
    column.ColumnName = "Item"
    column.AutoIncrement = False
    column.Caption = "Item"
    column.[ReadOnly] = False
    column.Unique = False
    table.Columns.Add(column)

    ' Create third column.
    column = New DataColumn()
    column.DataType = System.Type.[GetType]("System.String")
    column.ColumnName = "Data"
    column.AutoIncrement = False
    column.Caption = "Data"
    column.[ReadOnly] = False
    column.Unique = False
    ' Add the column to the table.
    table.Columns.Add(column)

    ' Create third column.
    column = New DataColumn()
    column.DataType = System.Type.[GetType]("System.String")
    column.ColumnName = "Group"
    column.AutoIncrement = False
    column.Caption = "Group"
    column.[ReadOnly] = False
    column.Unique = False
    ' Add the column to the table.
    table.Columns.Add(column)

    ' Make the ID column the primary key column.
    Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
    PrimaryKeyColumns(0) = table.Columns("id")
    table.PrimaryKey = PrimaryKeyColumns

    For i As Integer = 0 To 20
      row = table.NewRow()
      row("id") = i
      row("Item") = "Item " & i
      row("Data") = "Data " & i
      row("Group") = "Group " & IIf(i < 10, "One", "Two")
      table.Rows.Add(row)
    Next

    Return table
  End Function

End Class